/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.Turno;
import com.rjconsultores.ventaboletos.service.TurnoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("editarTurnoController")
@Scope("prototype")
public class EditarTurnoController extends MyGenericForwardComposer {

    @Autowired
    private TurnoService turnoService;
    private Turno turno;
    private MyListbox turnoList;
    private Button btnApagar;
    private MyTextbox txtNome;
    private static Logger log = Logger.getLogger(EditarTurnoController.class);

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public Turno getTurno() {
        return turno;
    }

    public void setTurno(Turno turno) {
        this.turno = turno;
    }

    public MyTextbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(MyTextbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        turno = (Turno) Executions.getCurrent().getArg().get("turno");
        turnoList = (MyListbox) Executions.getCurrent().getArg().get("turnoList");

        if (turno.getTurnoId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNome.getValue();

        try {
            turno.setActivo(Boolean.TRUE);
            turno.setFecmodif(Calendar.getInstance().getTime());
            turno.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            List<Turno> lsTurno = turnoService.buscar(turno.getDescturno());

            boolean podeSalvar = false;
            if (lsTurno.isEmpty()) {
                podeSalvar = true;
            } else {
                for (Turno t : lsTurno) {
                    if (t.getTurnoId().equals(turno.getTurnoId())) {
                        podeSalvar = true;
                    }
                }
            }


            if (!podeSalvar) {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarTurnoController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else {
                if (turno.getTurnoId() == null) {
                    turnoService.suscribir(turno);
                    turnoList.addItem(turno);
                } else {
                    turnoService.actualizacion(turno);
                    turnoList.updateItem(turno);
                }

                Messagebox.show(
                        Labels.getLabel("editarTurnoController.MSG.suscribirOK"),
                        Labels.getLabel("editarTurnoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error("editarTurnoController: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarTurnoController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarTurnoController.MSG.borrarPergunta"),
                    Labels.getLabel("editarTurnoController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                turnoService.borrar(turno);

                Messagebox.show(
                        Labels.getLabel("editarTurnoController.MSG.borrarOK"),
                        Labels.getLabel("editarTurnoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                turnoList.removeItem(turno);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
